
#ifndef PLUGIN_VMP_HEADER_H
#define PLUGIN_VMP_HEADER_H


// header for whole set of VMPs with global params
struct VMPs_Header
{
	int   NrOfVMPs;
	char  VMPFileName[301];

	int   XStart;  // do NOT change right now: if these 6 values are changed, you MUST also change the allocated memory of this and all other VMPs !
	int   XEnd;
	int   YStart;
	int   YEnd;
	int   ZStart;
	int   ZEnd;
	int   Resolution; // MUST be "1" at present

	// Note that X/Y/Z/End values are INCLUSIVE, this means that you must calculate the dimensions of the VMP block as:
	// dim_x = XEndVMP - XStartVMP + 1;
	// dim_y = YEndVMP - YStartVMP + 1;
	// dim_z = ZEndVMP - ZStartVMP + 1;
};

// header for ONE VMP
struct VMP_Header
{
	char  *NameOfVMP;

	int   MapType;
	int   ClusterSize;
	int   UseClusterSize;
	float ThreshMin;
	float ThreshMax;
	int   IncludeValuesGreaterThreshMax; // "1" (default) -> shows map values greater max threshold, "0" excludes values greater max threshold
	int   df1;
	int   df2;

	int   ColorPosMin;
	int   ColorPosMax;
	int   ColorNegMin;
	int   ColorNegMax;
	int   UseVMPColor;
	float TransparentColorFactor;

	int   NrOfMaskVoxels;

	int   OverlayMap;
};


#endif // PLUGIN_VMP_HEADER_H