#ifndef SURFACETOOL_H
#define SURFACETOOL_H

#include "BVQXPluginInterface.h"

/*
 * This class implements a plugin by deriving it from the generic PluginInterface
 */
class SurfaceTool : public BVQXPluginInterface
{
public:
	
	PLUGIN_ACCESS SurfaceTool();
	PLUGIN_ACCESS virtual ~SurfaceTool();

	PLUGIN_ACCESS bool execute();
	PLUGIN_ACCESS bool isAvailable() const;

private:
	
	bool checkPluginAvailability() const;
};

// To avoid C++ name mangling problems, we need to bootstrap access of plugin via C functions
//
extern "C" {
	PLUGIN_ACCESS BVQXPluginInterface *createPlugin();
	PLUGIN_ACCESS const char *getPluginName();
	PLUGIN_ACCESS const char *getPluginDescription();
	PLUGIN_ACCESS const char *getAuthor();
	PLUGIN_ACCESS const char *getHelpFile();
	PLUGIN_ACCESS const char *getRegistrationOfGenericComponentLoader(); 
}


#endif // SURFACETOOL_H
