

#if defined(OS_WIN32)
#include <windows.h>
#include <malloc.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <exception>
#include <math.h>
#include <string.h>

#include "BVQXPluginInterface.h"
#include "Plugin_SRF_Header.h"
#include "colortools.h"
#include "otherfunctions.h"

bool changeMeshColorRGB(SRF_Header *srfqx) {
  
		int cntr, border, nrvertices;
		nrvertices = srfqx->NrOfVertices;
		border = int(floor(nrvertices/5));
		int *newcolors = new int[nrvertices];
		char *colortxt = new char[256];
		sprintf(colortxt, "Number of vertices: %d", nrvertices);
		qxLogText(colortxt);
		sprintf(colortxt, "Current convex components: R: %f, G: %f, B: %f", 
			srfqx->Base1ColorR, srfqx->Base1ColorG, srfqx->Base1ColorB);
		qxLogText(colortxt);
		sprintf(colortxt, "Current concave components: R: %f, G: %f, B: %f", 
			srfqx->Base2ColorR, srfqx->Base2ColorG, srfqx->Base2ColorB);
		qxLogText(colortxt);

		char *logtxt = new char[256];
		sprintf(logtxt, "Please specify the range of vertices that should get a new color (number of vertices: %d)...", nrvertices);
		qxMessageBox(logtxt);

		int minval = 0;
		int defaultval = 0;
					
		char instrRangeMin[] = "Please enter the first vertex number of the range";
		int maxvert = srfqx->NrOfVertices;
		int minRange = qxGetIntegerInput(instrRangeMin, defaultval, minval, maxvert);
		char instrRangeMax[] = "Please enter the last vertex number of the range (inclusive)";
		int maxRange = qxGetIntegerInput(instrRangeMax, defaultval, minval, maxvert);									

			int min = 0;
			int max = 2000000000;
			
			int startval = 1056964608;
			int def = startval;
			
			int rgb = hexToDec();

			for (cntr = minRange; cntr < (maxRange + 1); cntr++) {
				srfqx->VertexColor[cntr] = startval + rgb;
			}
				
			qxUpdateActiveWindow();
				
			int save = qxYesNoMessageBox("Would you like to save the changes in a SRF file?");
			if (save) {
				char *newname = new char[256];
				char *bvpath = new char[256];
				qxGetBrainVoyagerQXPath(bvpath);
				int response = qxGetSaveFileName("Please enter the new SRF file name", bvpath, "Surface files (*.srf)", newname);
				if (response > 0) {
					qxSaveCurrentSRF(newname);
				}
			}
		
		return true;
}

void printColorsOfRangeToLogtab(SRF_Header *srfqx) {

	int minval = 0;
	int defaultval = 0;
	char instrRangeMin[] = "Please enter the first vertex number of the range";
	int maxvert = srfqx->NrOfVertices;
	int minRange = qxGetIntegerInput(instrRangeMin, defaultval, minval, maxvert);
	char instrRangeMax[] = "Please enter the last vertex number of the range (inclusive)";
	int maxRange = qxGetIntegerInput(instrRangeMax, defaultval, minval, maxvert);
	char *logtxt = new char[256];
	int cntr;
	for (cntr = minRange; cntr < (maxRange + 1); cntr++) {
		sprintf(logtxt, "Vertex: %d, value: %d", cntr, srfqx->VertexColor[cntr]);
		qxLogText(logtxt);
	}
}

int hexToDec() {

	int decimalValue;
	char *logtxt = new char[256];
	char instrHex[] = "Please enter the color in hexadecimals (without 0x)";
	char defaultTxt[] = "FFFFFF";
	char *hexText = new char[256];
	int response = qxGetTextInput(instrHex, defaultTxt, hexText);
	if (response > 0) {
		
		sprintf(logtxt, "The color entered in hexadecimal format is: %s", hexText);
		qxLogText(logtxt);
		
		decimalValue = hexToDec(hexText);
		
		sprintf(logtxt, "The corresponding decimal value is: %d", decimalValue);
		qxLogText(logtxt);
	}
	return decimalValue;
}

int hexToDec(char *hexstring) {


	int counter;
	int dec = 0;
	char ch;
	int len = strlen(hexstring)-1;
	for (counter = 0; counter <= len; counter++) {

		ch = hexstring[len - counter];

		switch (ch) {

			case 'F': 
				dec += (((counter == 0) ? 15: 
				(counter == 1) ? 15 * 16:
				15 * pow(16, counter))); 
				break;
			case 'E': 
				dec += (((counter == 0) ? 14: 
				(counter == 1) ? 14 * 16:
				14 * pow(16, counter))); 
				break;
			case 'D': 
				dec += (((counter == 0) ? 13: 
				(counter == 1) ? 13 * 16:
				13 * pow(16, counter)));  
				break;
			case 'C': 
				dec += (((counter == 0) ? 12: 
				(counter == 1) ? 12 * 16 :
				12 * pow(16, counter))); 
				break;
			case 'B': 
				dec += (((counter == 0) ? 11: 
				(counter == 1) ? 11 * 16:
				11 * pow(16, counter))); 
				break;
			case 'A': 
				dec += (((counter == 0) ? 10: 
				(counter == 1) ? 10 * 16:
				10 * pow(16, counter))); 
				break;
			case '9':  
				dec += (((counter == 0) ? 9: 
				(counter == 1) ? 9 * 16 :
				9 * pow(16, counter))); 
				break;
			case '8': 
				dec += (((counter == 0) ? 8: 
				(counter == 1) ? 8 * 16 :
				8 * pow(16, counter))); 
				break;
			case '7': dec += (((counter == 0) ? 7: 
				(counter == 1) ? 7 * 16:
				7 * pow(16, counter)));  
				break;
			case '6': dec += (((counter == 0) ? 6: 
				(counter == 1) ? 6 * 16:
				6 * pow(16, counter))); 
				break;
			case '5': dec += (((counter == 0) ? 5: 
				(counter == 1) ? 5 * 16:
				5 * pow(16, counter))); 
				break;
			case '4': dec += (((counter == 0) ? 4: 
				(counter == 1) ? 4 * 16:
				4 * pow(16, counter))); 
				break;
			case '3': dec += (((counter == 0) ? 3: 
				(counter == 1) ? 3 * 16:
				3 * pow(16, counter))); 
				break;
			case '2': dec += (((counter == 0) ? 2: 
				(counter == 1) ? 2 * 16:
				2 * pow(16, counter))); 
				break;
			case '1': dec += (((counter == 0) ? 1: 
				(counter == 1) ? 1 * 16:
				1 * pow(16, counter))); 
				break;
			case '0': dec += (((counter == 0) ? 0: 
				(counter == 1) ? 0 * 16 :
				0 * pow(16, counter))); 
				break;		
		}
	}

	return dec;
}

