																 

#ifndef COLORTOOLS_H
#define COLORTOOLS_H

/** Change a range of colors of a mesh
@param SRF_Header as defined in Plugin_SRF_Header.h
@return Success
@doc The function could change indices to the convex (0) and concave (1) colors in the headers
but if a hexadecimal RGB value is provided, the function will change the RGB colors. 		\\
This is performed by converting the value to decimals and adding it to the start value 1056964608.
*/
bool changeMeshColorRGB(SRF_Header *srfqx);			

/** Print a range of mesh colors to the BrainVoyager Log tab.
@param SRF_Header as defined in Plugin_SRF_Header.h
@doc The range will be asked from the user by means of interactive dialogs.
*/
void printColorsOfRangeToLogtab(SRF_Header *srfqx);	

/** Write some values of the current surface to ascii.
@param SRF_Header as defined in Plugin_SRF_Header.h
@return Ascii containing the header information
@doc Can be used to write the header values to the BrainVoyager QX Log tab or to a text file.
*/
char *currentsrfhdr2ascii(SRF_Header *srf);	

/** Interactive version of the hexToDec() function. Invokes the non-interactive one.
*/
int hexToDec();

/** This function converts hexadecimal to decimal numbers.
@param hexstring A regular string containing the hexadecimal number
@int The decimal value
@doc Used by the function changeMeshColorRGB().
*/
int hexToDec(char *hexstring);				



#endif // COLORTOOLS_H