
			  
#ifndef OTHERFUNCTIONS_H
#define OTHERFUNCTIONS_H

#define FUNCTION_CHANGECOLORS		1
#define FUNCTION_PRINTHDRTOLOG		2
#define FUNCTION_PRINTCOLORSTOLOG	3
#define FUNCTION_HEX2DEC			4
#define FUNCTION_WRITEHDRTOFILE		5

#include "Plugin_SRF_Header.h"

/** Write the information in the header of the current surface to ascii.
@param SRF_Header Pointer to SRF_Header as defined in Plugin_SRF_Header.h
@return Ascii data with the header information
@doc For this function, thanks to R.W. Cox.
*/
char *currentsrfhdr2ascii(SRF_Header *srf);

/** Write the information in the header of the current surface to a text file.
@param SRF_Header Pointer to SRF_Header as defined in Plugin_SRF_Header.h
@doc The name of the text file will reside in the same folder as the surface file,
with the same name.
*/
void writecurrentsrfhdr(SRF_Header *srf, char *txt);

/** Function to exchange the extension of a file.
@param Current file name
@param New extension for the file name (including '.', f.e. ".txt")
@return	File name with new extension
*/
char *exchangeExtension(char *currentFileName, char *newExtension);

/** Function to remove an extension of a filename.
@char Filename
@return Filename without extension
*/
char *removeExtension(char *fileName);

//char *getFunctionDescrList(int list[],int sizelist, bool htmlend);
char *getFunctionDescrList(char *prologue, int list[], int sizelist, bool htmlend, char *epilogue);

char *getFunctionDescr(int functionnr);
	

#endif // OTHERFUNCTIONS_H